javascript:
VALUES = {
    LOGIN_BUTTON_REG:new RegExp(window.mxautofill.getLoginButtonSignatureCodes(),"gi"),
    NONE_LOGIN_BUTTON_REG:new RegExp(window.mxautofill.getNonLoginButtonSignatureCodes(),"gi"),
    DOCUMENT_POSTION_NONE : 1<<0,
    DOCUMENT_POSTION_AFTER : 1<<1,
    DOCUMENT_POSTION_BEFORE : 1<<2,
    DOCUMENT_POSTION_INSIDE : 1<<3,
    DOCUMENT_POSTION_OUTSIDE : 1<<4,
    DOCUMENT_POSTION_EQUAL : 1<<5
};
var formInput = findUserNameAndPasswordInput();
function maybeUserName(node, form) {
//  console.log("maybeUserName:"+node.value+",id="+node.id);
  if (form != null && !form.hasChildNodes(node)) {
    //不考虑与密码框不在同一个表单内的输入框
    return false;
  }
  if (!isTextBox(node) || isHidden(node)) {
    //不考虑非输入框和隐藏的输入框
    return false;
  }
  if (attrCheck(node, window.mxautofill.getUsernameSignatureCodes())) {
    return true;
  }
  if(contentCheck(node, window.mxautofill.getUsernameSignatureCodes())) {
      return true;
  }
  return false;
}

function maybeVerifyCode(node) {
  if (!(node.type == 'text')
       || isHidden(node)) {
    //不考虑非输入框和隐藏的输入框
    return false;
  }
  if (attrCheck(node, ['vcode', 'verifycode'])) {
    return true;
  }
  if(contentCheck(node, "验证码")) {
    return true;
  }
  return false;
}

function doCheckAndFillPhoneNumber() { //将所有需要输入手机号的地方填充手机号
    var inputList = document.getElementsByTagName('input');
    for (var i = 0; i < inputList.length; ++i) {
        var node = inputList[i];
        if (!isHidden(node)) {
            if ((node.type == 'tel' || node.type == 'text' || node.type == 'number')
                && (contentCheck(node, "手机号|(phone\s*number)"))) {
                return node;
            }
        }
    }
}

function isHidden(node) {
    if (node.nodeName == 'BODY') return false;
    if (node.hidden || node.style.display == 'none') return true;
    if (node.parentNode) return isHidden(node.parentNode);
    return false;
}

function attrCheck(node, bakArr) {
    for (var i = 0; i < bakArr.length; ++i) {
        if ((node.id && node.id.toLowerCase().search(bakArr[i])>=0) || (node.name && node.name.toLowerCase().search(bakArr[i])>=0)) {
            return true;
        }
    }
    return false;
}

function contentCheck(node, regex) {
    regex = new RegExp(regex,"gi");
    if ((node.value && node.value.search(regex) >= 0) || (node.placeholder && node.placeholder.search(regex) >= 0)) {
        return true;
    }
    return false;
}

function strAttr(node, attrName) {
    var nodeValue = node[attrName];
    if (typeof(nodeValue) == "string") {
        return nodeValue;
    } else {
        nodeValue = node.getAttribute(attrName);
        if (typeof(nodeValue) == "string") {
            return nodeValue;
        } else {
            return "";
        }
   }
}

function catchForm(document) {
  var checkAndFillPhoneNumber = true;
  var inputList = document.getElementsByTagName('input');
  var form;
  var usernameInput;
  var usernameIdx = -1;
  var passwordInput;
  var passwordIdx = -1;
  var verifycodeInput;
  var verifycodeIdx = -1;
  var formJson;
  for (var i = 0; i < inputList.length; ++i) {
    if (inputList[i].type == 'password' && !isHidden(inputList[i])) {
      passwordIdx = i;
      passwordInput = inputList[i];
      form = inputList[i].form;
      break;
    }
  }
  if (passwordIdx <= 0) {
    //此种情况可能是没有密码框或者密码框排在了第一个位置(可能是某种修改密码的页面), 推测非正常的登陆页, 为保险不做处理
    if (checkAndFillPhoneNumber) {
        usernameInput = doCheckAndFillPhoneNumber();
    }
    return;
  } else if (passwordIdx == 1) {
    //此种情况页属推测, 第二个是密码框, 则第一个应该是"昵称/用户名/邮箱/手机号/其他帐号"
    usernameIdx = 0;
    usernameInput = inputList[0];
  } else {
    //从密码框往前遍历寻找可能的用户名框
    for (var i = passwordIdx - 1; i >= 0; --i) {
      if (maybeUserName(inputList[i], form)) {
        usernameIdx = i;
        usernameInput = inputList[i];
        break;
      }
    }
  }
  for (var i = passwordIdx + 1; i < inputList.length; ++i) {
    if (maybeVerifyCode(inputList[i])) {
      verifycodeIdx = i;
      verifycodeInput = inputList[i];
    }
  }
  if(usernameInput && passwordInput){
    var info = {};
    info.usernameInput = usernameInput;
    info.passwordInput = passwordInput;
    return info;
  }
  return null;
}

function loginButtonCheck(name){
  return name.search(VALUES.LOGIN_BUTTON_REG)>=0 && name.search(VALUES.NONE_LOGIN_BUTTON_REG)<0;
}
// 判断是否是可填写的类输入框
function isTextBox(el) {
    if (el && !el.disabled && /password|text|email|tel|number|search|textarea/i.test(el.type)) {
        return true;
    }
    return false;
}

function findUserNameAndPasswordInput(){
  var info = catchForm(window.document);
    if(info==null){
      try {
          var frameNodes = window.document.getElementsByTagName('iframe');
          if (frameNodes.length > 0) {
              for (var i = 0; i < frameNodes.length; ++i) {
                  info = catchForm(frameNodes[i].contentWindow.document);
              }
          }
      } catch (e) {
          console.log(e.message);
      }
    }
    return info;
}

function hookLoginAction2(node, loginBtns, passwordNode){
    if(!isTextBox(node)&&node.hasAttribute&&((passwordNode.compareDocumentPosition(node))&VALUES.DOCUMENT_POSTION_BEFORE)){//密码框在登录按钮之前
        var id = strAttr(node,"id");
        var name = strAttr(node,"name");
        var value = strAttr(node,"value");
        var type = strAttr(node,"type");
        var className = strAttr(node,"class");
        var innerHTML = node.innerHTML ? node.innerHTML : "";
        if(loginButtonCheck(id) || loginButtonCheck(name) || loginButtonCheck(className) || loginButtonCheck(value) || innerHTML == "登录"){
            console.log("success id="+id+",name="+name+",value="+value+",className="+className+",type="+type+",innerHTML="+innerHTML);
            loginBtns.push(node);
        }
    }
}

function mx_login_hook() {
//    console.log("inject catch form js");
//    console.log("signature username : "+window.mxautofill.getLoginButtonSignatureCodes());
//    console.log("signature nonusername : "+window.mxautofill.getNonLoginButtonSignatureCodes());
//    console.log("signature loginbutton : "+window.mxautofill.getUsernameSignatureCodes());
//    console.log("signature nonloginbutton : "+window.mxautofill.getUsernameSignatureCodes());
    var info = formInput;
    if(info){
        console.log("has username and password");
        var parent = null;
        var sibling = null;
        var nextSibling = null;
        var loginBtns = [];
        var forms = window.document.getElementsByTagName("form");
        var buttons = window.document.getElementsByTagName("button");
        var inputs = window.document.getElementsByTagName("input");
        var as = window.document.getElementsByTagName("a");
        if(forms){
            console.log("start to find login button in forms");
            for( var i = 0 ; i < forms.length; ++i){
              forms[i].addEventListener("submit", function(e){
                console.log("form submited"+e.id);
                var formData = {};
                formData.documentURI = window.document.documentURI;
                formData.inputs = [];
                var username = {};
                username.id = "username";
                username.name = "username";
                username.value = info.usernameInput.value;
                formData.inputs.push(username);
                var password = {};
                password.id = "password";
                password.name = "password";
                password.value = info.passwordInput.value;
                formData.inputs.push(password);
                var json = JSON.stringify(formData);
                window.mxautofill.catchform(json);
              },false);
            }
        }
        if(buttons){
            console.log("start to find login button in buttons");
            for(var i = 0; i < buttons.length; ++i){
              hookLoginAction2(buttons[i],loginBtns,info.passwordInput);
            }
        }
        if(inputs){
            console.log("start to find login button in inputs");
            for(var i = 0; i < inputs.length; ++i){
              hookLoginAction2(inputs[i],loginBtns,info.passwordInput);
            }
        }
        if(as){
          console.log("start to find login button in as");
          for( var i = 0; i < as.length; ++i){
            hookLoginAction2(as[i],loginBtns,info.passwordInput);
          }
        }
        
        if(loginBtns.length>0){
          console.log("may be have found login button");
          for( var i = 0; i < loginBtns.length; ++i){
            loginBtns[i].addEventListener("click",function(e){
                console.log("loginBtn clicked"+e.id);
                var formData = {};
                formData.documentURI = window.document.documentURI;
                formData.inputs = [];
                var username = {};
                username.id = "username";
                username.name = "username";
                username.value = info.usernameInput.value;
                formData.inputs.push(username);
                var password = {};
                password.id = "password";
                password.name = "password";
                password.value = info.passwordInput.value;
                formData.inputs.push(password);
                var json = JSON.stringify(formData);
                window.mxautofill.catchform(json);
            },false);
          }
        }
    }
}


function mx_form_fill(username,password) {
  if(!window.mxautofill){
    console.log("cannot find mxautofill");
  }
  var info = formInput;
  if(info){
      info.usernameInput.value = username;
      info.passwordInput.value = password;
  }
}

function mx_auto_fill(){
    var enableAutoFill = window.mxautofill.enableAutoFill();
    mx_form_fill();
    if(enableAutoFill){
        mx_login_hook();
    }
}
// mx_auto_fill();
